org.apache.hadoop.fs.http.client

## Class HttpFSFileSystem

- java.lang.Object
- - org.apache.hadoop.conf.Configured
  - - org.apache.hadoop.fs.FileSystem
    - - org.apache.hadoop.fs.http.client.HttpFSFileSystem

- All Implemented Interfaces:
    Closeable, AutoCloseable, org.apache.hadoop.conf.Configurable, org.apache.hadoop.fs.DelegationTokenRenewer.Renewable, org.apache.hadoop.fs.PathCapabilities, org.apache.hadoop.security.token.DelegationTokenIssuer
  Direct Known Subclasses:
    HttpsFSFileSystem

      @InterfaceAudience.Private
      public class HttpFSFileSystem
      extends org.apache.hadoop.fs.FileSystem
      implements org.apache.hadoop.fs.DelegationTokenRenewer.Renewable

  HttpFSServer implementation of the FileSystemAccess FileSystem.

  This implementation allows a user to access HDFS over HTTP via a HttpFSServer server.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `HttpFSFileSystem.FILE_TYPE`
    `static class` | `HttpFSFileSystem.Operation`

    - ### Nested classes/interfaces inherited from class org.apache.hadoop.fs.FileSystem

      `org.apache.hadoop.fs.FileSystem.DirectoryEntries, org.apache.hadoop.fs.FileSystem.DirListingIterator<T extends org.apache.hadoop.fs.FileStatus>, org.apache.hadoop.fs.FileSystem.Statistics`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `ACCESS_TIME_JSON`
    `static String` | `ACCESS_TIME_PARAM`
    `static String` | `ACL_BIT_JSON`
    `static String` | `ACL_ENTRIES_JSON`
    `static String` | `ACL_STATUS_JSON`
    `static String` | `ACL_STICKY_BIT_JSON`
    `static String` | `ACLSPEC_DEFAULT`
    `static String` | `ACLSPEC_PARAM`
    `static String` | `BLOCK_SIZE_JSON`
    `static String` | `BLOCKSIZE_PARAM`
    `static String` | `CHECKSUM_ALGORITHM_JSON`
    `static String` | `CHECKSUM_BYTES_JSON`
    `static String` | `CHECKSUM_LENGTH_JSON`
    `static String` | `CHILDREN_NUM_JSON`
    `static String` | `CONTENT_SUMMARY_DIRECTORY_COUNT_JSON`
    `static String` | `CONTENT_SUMMARY_ECPOLICY_JSON`
    `static String` | `CONTENT_SUMMARY_FILE_COUNT_JSON`
    `static String` | `CONTENT_SUMMARY_JSON`
    `static String` | `CONTENT_SUMMARY_LENGTH_JSON`
    `static Short` | `DEFAULT_PERMISSION`
    `static String` | `DELETE_JSON`
    `static String` | `DESTINATION_PARAM`
    `static String` | `DIRECTORY_LISTING_JSON`
    `static String` | `DO_AS_PARAM`
    `static String` | `EC_BIT_JSON`
    `static String` | `ENC_BIT_JSON`
    `static String` | `FILE_CHECKSUM_JSON`
    `static String` | `FILE_ID_JSON`
    `static String` | `FILE_STATUS_JSON`
    `static String` | `FILE_STATUSES_JSON`
    `static String` | `GROUP_JSON`
    `static String` | `GROUP_PARAM`
    `static String` | `HOME_DIR_JSON`
    `static int` | `HTTP_TEMPORARY_REDIRECT`
    `static String` | `LENGTH_JSON`
    `static String` | `MKDIRS_JSON`
    `static String` | `MODIFICATION_TIME_JSON`
    `static String` | `MODIFICATION_TIME_PARAM`
    `static String` | `NEW_LENGTH_PARAM`
    `static String` | `OLD_SNAPSHOT_NAME_PARAM`
    `static String` | `OP_PARAM`
    `static String` | `OVERWRITE_PARAM`
    `static String` | `OWNER_JSON`
    `static String` | `OWNER_PARAM`
    `static String` | `PARTIAL_LISTING_JSON`
    `static String` | `PATH_SUFFIX_JSON`
    `static String` | `PERMISSION_JSON`
    `static String` | `PERMISSION_PARAM`
    `static String` | `POLICY_NAME_PARAM`
    `static String` | `QUOTA_USAGE_CONSUMED_JSON`
    `static String` | `QUOTA_USAGE_FILE_AND_DIRECTORY_COUNT_JSON`
    `static String` | `QUOTA_USAGE_JSON`
    `static String` | `QUOTA_USAGE_QUOTA_JSON`
    `static String` | `QUOTA_USAGE_SPACE_CONSUMED_JSON`
    `static String` | `QUOTA_USAGE_SPACE_QUOTA_JSON`
    `static String` | `QUOTA_USAGE_TYPE_QUOTA_JSON`
    `static String` | `RECURSIVE_PARAM`
    `static String` | `REMAINING_ENTRIES_JSON`
    `static String` | `RENAME_JSON`
    `static String` | `REPLICATION_JSON`
    `static String` | `REPLICATION_PARAM`
    `static String` | `SCHEME`
    `static String` | `SERVICE_NAME`
    `static String` | `SERVICE_VERSION`
    `static String` | `SET_REPLICATION_JSON`
    `static String` | `SNAPSHOT_BIT_JSON`
    `static String` | `SNAPSHOT_JSON`
    `static String` | `SNAPSHOT_NAME_PARAM`
    `static String` | `SOURCES_PARAM`
    `static String` | `START_AFTER_PARAM`
    `static String` | `STORAGE_POLICIES_JSON`
    `static String` | `STORAGE_POLICY_JSON`
    `static String` | `STORAGEPOLICY_JSON`
    `static String` | `SYMLINK_JSON`
    `static String` | `TRASH_DIR_JSON`
    `static String` | `TRUNCATE_JSON`
    `static String` | `TYPE_JSON`
    `static String` | `UNMASKED_PERMISSION_PARAM`
    `static String` | `UPLOAD_CONTENT_TYPE`
    `static String` | `XATTR_ENCODING_PARAM`
    `static String` | `XATTR_NAME_JSON`
    `static String` | `XATTR_NAME_PARAM`
    `static String` | `XATTR_SET_FLAG_PARAM`
    `static String` | `XATTR_VALUE_JSON`
    `static String` | `XATTR_VALUE_PARAM`
    `static String` | `XATTRNAMES_JSON`
    `static String` | `XATTRS_JSON`

    - ### Fields inherited from class org.apache.hadoop.fs.FileSystem

      `DEFAULT_FS, FS_DEFAULT_NAME_KEY, LOG, SHUTDOWN_HOOK_PRIORITY, statistics, TRASH_PREFIX, USER_HOME_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `HttpFSFileSystem()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `allowSnapshot(org.apache.hadoop.fs.Path path)`
    `org.apache.hadoop.fs.FSDataOutputStream` | `append(org.apache.hadoop.fs.Path f, int bufferSize, org.apache.hadoop.util.Progressable progress)` Append to an existing file (optional operation).
    `void` | `cancelDelegationToken(org.apache.hadoop.security.token.Token<?> token)`
    `void` | `concat(org.apache.hadoop.fs.Path f, org.apache.hadoop.fs.Path[] psrcs)` Concat existing files together.
    `org.apache.hadoop.fs.FSDataOutputStream` | `create(org.apache.hadoop.fs.Path f, org.apache.hadoop.fs.permission.FsPermission permission, boolean overwrite, int bufferSize, short replication, long blockSize, org.apache.hadoop.util.Progressable progress)` Opens an FSDataOutputStream at the indicated Path with write-progress reporting.
    `org.apache.hadoop.fs.Path` | `createSnapshot(org.apache.hadoop.fs.Path path, String snapshotName)`
    `boolean` | `delete(org.apache.hadoop.fs.Path f)` Deprecated. Use delete(Path, boolean) instead
    `boolean` | `delete(org.apache.hadoop.fs.Path f, boolean recursive)` Delete a file.
    `void` | `deleteSnapshot(org.apache.hadoop.fs.Path path, String snapshotName)`
    `void` | `disallowSnapshot(org.apache.hadoop.fs.Path path)`
    `org.apache.hadoop.fs.permission.AclStatus` | `getAclStatus(org.apache.hadoop.fs.Path path)` Get the ACL information for a given file
    `Collection<org.apache.hadoop.hdfs.protocol.BlockStoragePolicy>` | `getAllStoragePolicies()`
    `org.apache.hadoop.fs.ContentSummary` | `getContentSummary(org.apache.hadoop.fs.Path f)`
    `protected int` | `getDefaultPort()` Get the default port for this file system.
    `org.apache.hadoop.security.token.Token<?>` | `getDelegationToken(String renewer)`
    `org.apache.hadoop.fs.FileChecksum` | `getFileChecksum(org.apache.hadoop.fs.Path f)`
    `org.apache.hadoop.fs.FileStatus` | `getFileStatus(org.apache.hadoop.fs.Path f)` Return a file status object that represents the path.
    `org.apache.hadoop.fs.Path` | `getHomeDirectory()` Return the current user's home directory in this filesystem.
    `org.apache.hadoop.fs.QuotaUsage` | `getQuotaUsage(org.apache.hadoop.fs.Path f)`
    `org.apache.hadoop.security.token.Token<?>` | `getRenewToken()`
    `String` | `getScheme()`
    `org.apache.hadoop.hdfs.protocol.SnapshotDiffReport` | `getSnapshotDiffReport(org.apache.hadoop.fs.Path path, String snapshotOldName, String snapshotNewName)`
    `org.apache.hadoop.hdfs.protocol.SnapshottableDirectoryStatus[]` | `getSnapshottableDirectoryList()`
    `org.apache.hadoop.hdfs.protocol.BlockStoragePolicy` | `getStoragePolicy(org.apache.hadoop.fs.Path src)`
    `org.apache.hadoop.fs.Path` | `getTrashRoot(org.apache.hadoop.fs.Path fullPath)` Get the root directory of Trash for a path in HDFS.
    `URI` | `getUri()` Returns a URI whose scheme and authority identify this FileSystem.
    `org.apache.hadoop.fs.Path` | `getWorkingDirectory()` Get the current working directory for the given file system
    `byte[]` | `getXAttr(org.apache.hadoop.fs.Path f, String name)`
    `Map<String,byte[]>` | `getXAttrs(org.apache.hadoop.fs.Path f)`
    `Map<String,byte[]>` | `getXAttrs(org.apache.hadoop.fs.Path f, List<String> names)`
    `boolean` | `hasPathCapability(org.apache.hadoop.fs.Path path, String capability)` This filesystem's capabilities must be in sync with that of `DistributedFileSystem.hasPathCapability()` except where the feature is not exposed (e.g.
    `void` | `initialize(URI name, org.apache.hadoop.conf.Configuration conf)` Called after a new FileSystem instance is constructed.
    `org.apache.hadoop.fs.FileStatus[]` | `listStatus(org.apache.hadoop.fs.Path f)` Get `FileStatus` of files/directories in the given path.
    `org.apache.hadoop.fs.FileSystem.DirectoryEntries` | `listStatusBatch(org.apache.hadoop.fs.Path f, byte[] token)` Get `DirectoryEntries` of the given path.
    `List<String>` | `listXAttrs(org.apache.hadoop.fs.Path f)`
    `boolean` | `mkdirs(org.apache.hadoop.fs.Path f, org.apache.hadoop.fs.permission.FsPermission permission)` Make the given file and all non-existent parents into directories.
    `void` | `modifyAclEntries(org.apache.hadoop.fs.Path path, List<org.apache.hadoop.fs.permission.AclEntry> aclSpec)` Modify the ACL entries for a file.
    `org.apache.hadoop.fs.FSDataInputStream` | `open(org.apache.hadoop.fs.Path f, int bufferSize)` Opens an FSDataInputStream at the indicated Path.
    `static String` | `permissionToString(org.apache.hadoop.fs.permission.FsPermission p)` Converts a `FsPermission` to a Unix octal representation.
    `void` | `removeAcl(org.apache.hadoop.fs.Path path)` Remove all ACLs from a file
    `void` | `removeAclEntries(org.apache.hadoop.fs.Path path, List<org.apache.hadoop.fs.permission.AclEntry> aclSpec)` Remove the specified ACL entries from a file
    `void` | `removeDefaultAcl(org.apache.hadoop.fs.Path path)` Removes the default ACL for the given file
    `void` | `removeXAttr(org.apache.hadoop.fs.Path f, String name)`
    `boolean` | `rename(org.apache.hadoop.fs.Path src, org.apache.hadoop.fs.Path dst)` Renames Path src to Path dst.
    `void` | `renameSnapshot(org.apache.hadoop.fs.Path path, String snapshotOldName, String snapshotNewName)`
    `long` | `renewDelegationToken(org.apache.hadoop.security.token.Token<?> token)`
    `void` | `setAcl(org.apache.hadoop.fs.Path path, List<org.apache.hadoop.fs.permission.AclEntry> aclSpec)` Set the ACLs for the given file
    `<T extends org.apache.hadoop.security.token.TokenIdentifier> void` | `setDelegationToken(org.apache.hadoop.security.token.Token<T> token)`
    `void` | `setOwner(org.apache.hadoop.fs.Path p, String username, String groupname)` Set owner of a path (i.e.
    `void` | `setPermission(org.apache.hadoop.fs.Path p, org.apache.hadoop.fs.permission.FsPermission permission)` Set permission of a path.
    `boolean` | `setReplication(org.apache.hadoop.fs.Path src, short replication)` Set replication for an existing file.
    `void` | `setStoragePolicy(org.apache.hadoop.fs.Path src, String policyName)`
    `void` | `setTimes(org.apache.hadoop.fs.Path p, long mtime, long atime)` Set access time of a file
    `void` | `setWorkingDirectory(org.apache.hadoop.fs.Path newDir)` Set the current working directory for the given file system.
    `void` | `setXAttr(org.apache.hadoop.fs.Path f, String name, byte[] value, EnumSet<org.apache.hadoop.fs.XAttrSetFlag> flag)`
    `boolean` | `truncate(org.apache.hadoop.fs.Path f, long newLength)` Truncate a file.
    `void` | `unsetStoragePolicy(org.apache.hadoop.fs.Path src)`

    - ### Methods inherited from class org.apache.hadoop.fs.FileSystem

      `access, append, append, appendFile, areSymlinksEnabled, cancelDeleteOnExit, canonicalizeUri, checkPath, clearStatistics, close, closeAll, closeAllForUGI, completeLocalOutput, copyFromLocalFile, copyFromLocalFile, copyFromLocalFile, copyFromLocalFile, copyToLocalFile, copyToLocalFile, copyToLocalFile, create, create, create, create, create, create, create, create, create, create, create, create, createFile, createNewFile, createNonRecursive, createNonRecursive, createNonRecursive, createPathHandle, createSnapshot, createSymlink, deleteOnExit, enableSymlinks, exists, fixRelativePart, get, get, get, getAdditionalTokenIssuers, getAllStatistics, getBlockSize, getCanonicalServiceName, getCanonicalUri, getChildFileSystems, getDefaultBlockSize, getDefaultBlockSize, getDefaultReplication, getDefaultReplication, getDefaultUri, getFileBlockLocations, getFileBlockLocations, getFileChecksum, getFileLinkStatus, getFileSystemClass, getFSofPath, getGlobalStorageStatistics, getInitialWorkingDirectory, getLength, getLinkTarget, getLocal, getName, getNamed, getPathHandle, getReplication, getServerDefaults, getServerDefaults, getStatistics, getStatistics, getStatus, getStatus, getStorageStatistics, getTrashRoots, getUsed, getUsed, globStatus, globStatus, isDirectory, isFile, listCorruptFileBlocks, listFiles, listLocatedStatus, listLocatedStatus, listStatus, listStatus, listStatus, listStatusIterator, makeQualified, mkdirs, mkdirs, moveFromLocalFile, moveFromLocalFile, moveToLocalFile, msync, newInstance, newInstance, newInstance, newInstanceLocal, open, open, open, primitiveCreate, primitiveMkdir, primitiveMkdir, printStatistics, processDeleteOnExit, rename, resolveLink, resolvePath, satisfyStoragePolicy, setDefaultUri, setDefaultUri, setQuota, setQuotaByStorageType, setVerifyChecksum, setWriteChecksum, setXAttr, startLocalOutput, supportsSymlinks`

    - ### Methods inherited from class org.apache.hadoop.conf.Configured

      `getConf, setConf`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.hadoop.security.token.DelegationTokenIssuer

      `addDelegationTokens, collectDelegationTokens`

- - ### Field Detail

    - #### SERVICE_NAME

          public static final String SERVICE_NAME

      See Also:
        Constant Field Values

    - #### SERVICE_VERSION

          public static final String SERVICE_VERSION

      See Also:
        Constant Field Values

    - #### SCHEME

          public static final String SCHEME

      See Also:
        Constant Field Values

    - #### OP_PARAM

          public static final String OP_PARAM

      See Also:
        Constant Field Values

    - #### DO_AS_PARAM

          public static final String DO_AS_PARAM

      See Also:
        Constant Field Values

    - #### OVERWRITE_PARAM

          public static final String OVERWRITE_PARAM

      See Also:
        Constant Field Values

    - #### REPLICATION_PARAM

          public static final String REPLICATION_PARAM

      See Also:
        Constant Field Values

    - #### BLOCKSIZE_PARAM

          public static final String BLOCKSIZE_PARAM

      See Also:
        Constant Field Values

    - #### PERMISSION_PARAM

          public static final String PERMISSION_PARAM

      See Also:
        Constant Field Values

    - #### UNMASKED_PERMISSION_PARAM

          public static final String UNMASKED_PERMISSION_PARAM

      See Also:
        Constant Field Values

    - #### ACLSPEC_PARAM

          public static final String ACLSPEC_PARAM

      See Also:
        Constant Field Values

    - #### DESTINATION_PARAM

          public static final String DESTINATION_PARAM

      See Also:
        Constant Field Values

    - #### RECURSIVE_PARAM

          public static final String RECURSIVE_PARAM

      See Also:
        Constant Field Values

    - #### SOURCES_PARAM

          public static final String SOURCES_PARAM

      See Also:
        Constant Field Values

    - #### OWNER_PARAM

          public static final String OWNER_PARAM

      See Also:
        Constant Field Values

    - #### GROUP_PARAM

          public static final String GROUP_PARAM

      See Also:
        Constant Field Values

    - #### MODIFICATION_TIME_PARAM

          public static final String MODIFICATION_TIME_PARAM

      See Also:
        Constant Field Values

    - #### ACCESS_TIME_PARAM

          public static final String ACCESS_TIME_PARAM

      See Also:
        Constant Field Values

    - #### XATTR_NAME_PARAM

          public static final String XATTR_NAME_PARAM

      See Also:
        Constant Field Values

    - #### XATTR_VALUE_PARAM

          public static final String XATTR_VALUE_PARAM

      See Also:
        Constant Field Values

    - #### XATTR_SET_FLAG_PARAM

          public static final String XATTR_SET_FLAG_PARAM

      See Also:
        Constant Field Values

    - #### XATTR_ENCODING_PARAM

          public static final String XATTR_ENCODING_PARAM

      See Also:
        Constant Field Values

    - #### NEW_LENGTH_PARAM

          public static final String NEW_LENGTH_PARAM

      See Also:
        Constant Field Values

    - #### START_AFTER_PARAM

          public static final String START_AFTER_PARAM

      See Also:
        Constant Field Values

    - #### POLICY_NAME_PARAM

          public static final String POLICY_NAME_PARAM

      See Also:
        Constant Field Values

    - #### SNAPSHOT_NAME_PARAM

          public static final String SNAPSHOT_NAME_PARAM

      See Also:
        Constant Field Values

    - #### OLD_SNAPSHOT_NAME_PARAM

          public static final String OLD_SNAPSHOT_NAME_PARAM

      See Also:
        Constant Field Values

    - #### DEFAULT_PERMISSION

          public static final Short DEFAULT_PERMISSION

    - #### ACLSPEC_DEFAULT

          public static final String ACLSPEC_DEFAULT

      See Also:
        Constant Field Values

    - #### RENAME_JSON

          public static final String RENAME_JSON

      See Also:
        Constant Field Values

    - #### TRUNCATE_JSON

          public static final String TRUNCATE_JSON

      See Also:
        Constant Field Values

    - #### DELETE_JSON

          public static final String DELETE_JSON

      See Also:
        Constant Field Values

    - #### MKDIRS_JSON

          public static final String MKDIRS_JSON

      See Also:
        Constant Field Values

    - #### HOME_DIR_JSON

          public static final String HOME_DIR_JSON

      See Also:
        Constant Field Values

    - #### TRASH_DIR_JSON

          public static final String TRASH_DIR_JSON

      See Also:
        Constant Field Values

    - #### SET_REPLICATION_JSON

          public static final String SET_REPLICATION_JSON

      See Also:
        Constant Field Values

    - #### UPLOAD_CONTENT_TYPE

          public static final String UPLOAD_CONTENT_TYPE

      See Also:
        Constant Field Values

    - #### SNAPSHOT_JSON

          public static final String SNAPSHOT_JSON

      See Also:
        Constant Field Values

    - #### FILE_STATUSES_JSON

          public static final String FILE_STATUSES_JSON

      See Also:
        Constant Field Values

    - #### FILE_STATUS_JSON

          public static final String FILE_STATUS_JSON

      See Also:
        Constant Field Values

    - #### PATH_SUFFIX_JSON

          public static final String PATH_SUFFIX_JSON

      See Also:
        Constant Field Values

    - #### TYPE_JSON

          public static final String TYPE_JSON

      See Also:
        Constant Field Values

    - #### LENGTH_JSON

          public static final String LENGTH_JSON

      See Also:
        Constant Field Values

    - #### OWNER_JSON

          public static final String OWNER_JSON

      See Also:
        Constant Field Values

    - #### GROUP_JSON

          public static final String GROUP_JSON

      See Also:
        Constant Field Values

    - #### PERMISSION_JSON

          public static final String PERMISSION_JSON

      See Also:
        Constant Field Values

    - #### ACCESS_TIME_JSON

          public static final String ACCESS_TIME_JSON

      See Also:
        Constant Field Values

    - #### MODIFICATION_TIME_JSON

          public static final String MODIFICATION_TIME_JSON

      See Also:
        Constant Field Values

    - #### BLOCK_SIZE_JSON

          public static final String BLOCK_SIZE_JSON

      See Also:
        Constant Field Values

    - #### CHILDREN_NUM_JSON

          public static final String CHILDREN_NUM_JSON

      See Also:
        Constant Field Values

    - #### FILE_ID_JSON

          public static final String FILE_ID_JSON

      See Also:
        Constant Field Values

    - #### REPLICATION_JSON

          public static final String REPLICATION_JSON

      See Also:
        Constant Field Values

    - #### STORAGEPOLICY_JSON

          public static final String STORAGEPOLICY_JSON

      See Also:
        Constant Field Values

    - #### XATTRS_JSON

          public static final String XATTRS_JSON

      See Also:
        Constant Field Values

    - #### XATTR_NAME_JSON

          public static final String XATTR_NAME_JSON

      See Also:
        Constant Field Values

    - #### XATTR_VALUE_JSON

          public static final String XATTR_VALUE_JSON

      See Also:
        Constant Field Values

    - #### XATTRNAMES_JSON

          public static final String XATTRNAMES_JSON

      See Also:
        Constant Field Values

    - #### SYMLINK_JSON

          public static final String SYMLINK_JSON

      See Also:
        Constant Field Values

    - #### FILE_CHECKSUM_JSON

          public static final String FILE_CHECKSUM_JSON

      See Also:
        Constant Field Values

    - #### CHECKSUM_ALGORITHM_JSON

          public static final String CHECKSUM_ALGORITHM_JSON

      See Also:
        Constant Field Values

    - #### CHECKSUM_BYTES_JSON

          public static final String CHECKSUM_BYTES_JSON

      See Also:
        Constant Field Values

    - #### CHECKSUM_LENGTH_JSON

          public static final String CHECKSUM_LENGTH_JSON

      See Also:
        Constant Field Values

    - #### CONTENT_SUMMARY_JSON

          public static final String CONTENT_SUMMARY_JSON

      See Also:
        Constant Field Values

    - #### CONTENT_SUMMARY_DIRECTORY_COUNT_JSON

          public static final String CONTENT_SUMMARY_DIRECTORY_COUNT_JSON

      See Also:
        Constant Field Values

    - #### CONTENT_SUMMARY_ECPOLICY_JSON

          public static final String CONTENT_SUMMARY_ECPOLICY_JSON

      See Also:
        Constant Field Values

    - #### CONTENT_SUMMARY_FILE_COUNT_JSON

          public static final String CONTENT_SUMMARY_FILE_COUNT_JSON

      See Also:
        Constant Field Values

    - #### CONTENT_SUMMARY_LENGTH_JSON

          public static final String CONTENT_SUMMARY_LENGTH_JSON

      See Also:
        Constant Field Values

    - #### QUOTA_USAGE_JSON

          public static final String QUOTA_USAGE_JSON

      See Also:
        Constant Field Values

    - #### QUOTA_USAGE_FILE_AND_DIRECTORY_COUNT_JSON

          public static final String QUOTA_USAGE_FILE_AND_DIRECTORY_COUNT_JSON

      See Also:
        Constant Field Values

    - #### QUOTA_USAGE_QUOTA_JSON

          public static final String QUOTA_USAGE_QUOTA_JSON

      See Also:
        Constant Field Values

    - #### QUOTA_USAGE_SPACE_CONSUMED_JSON

          public static final String QUOTA_USAGE_SPACE_CONSUMED_JSON

      See Also:
        Constant Field Values

    - #### QUOTA_USAGE_SPACE_QUOTA_JSON

          public static final String QUOTA_USAGE_SPACE_QUOTA_JSON

      See Also:
        Constant Field Values

    - #### QUOTA_USAGE_CONSUMED_JSON

          public static final String QUOTA_USAGE_CONSUMED_JSON

      See Also:
        Constant Field Values

    - #### QUOTA_USAGE_TYPE_QUOTA_JSON

          public static final String QUOTA_USAGE_TYPE_QUOTA_JSON

      See Also:
        Constant Field Values

    - #### ACL_STATUS_JSON

          public static final String ACL_STATUS_JSON

      See Also:
        Constant Field Values

    - #### ACL_STICKY_BIT_JSON

          public static final String ACL_STICKY_BIT_JSON

      See Also:
        Constant Field Values

    - #### ACL_ENTRIES_JSON

          public static final String ACL_ENTRIES_JSON

      See Also:
        Constant Field Values

    - #### ACL_BIT_JSON

          public static final String ACL_BIT_JSON

      See Also:
        Constant Field Values

    - #### ENC_BIT_JSON

          public static final String ENC_BIT_JSON

      See Also:
        Constant Field Values

    - #### EC_BIT_JSON

          public static final String EC_BIT_JSON

      See Also:
        Constant Field Values

    - #### SNAPSHOT_BIT_JSON

          public static final String SNAPSHOT_BIT_JSON

      See Also:
        Constant Field Values

    - #### DIRECTORY_LISTING_JSON

          public static final String DIRECTORY_LISTING_JSON

      See Also:
        Constant Field Values

    - #### PARTIAL_LISTING_JSON

          public static final String PARTIAL_LISTING_JSON

      See Also:
        Constant Field Values

    - #### REMAINING_ENTRIES_JSON

          public static final String REMAINING_ENTRIES_JSON

      See Also:
        Constant Field Values

    - #### STORAGE_POLICIES_JSON

          public static final String STORAGE_POLICIES_JSON

      See Also:
        Constant Field Values

    - #### STORAGE_POLICY_JSON

          public static final String STORAGE_POLICY_JSON

      See Also:
        Constant Field Values

    - #### HTTP_TEMPORARY_REDIRECT

          public static final int HTTP_TEMPORARY_REDIRECT

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### HttpFSFileSystem

          public HttpFSFileSystem()

  - ### Method Detail

    - #### initialize

          public void initialize(URI name,
                                 org.apache.hadoop.conf.Configuration conf)
                          throws IOException

      Called after a new FileSystem instance is constructed.
      Overrides:
        `initialize` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `name` - a uri whose authority section names the host, port, etc. for this FileSystem
        `conf` - the configuration
      Throws:
        `IOException`

    - #### getScheme

          public String getScheme()

      Overrides:
        `getScheme` in class `org.apache.hadoop.fs.FileSystem`

    - #### getUri

          public URI getUri()

      Returns a URI whose scheme and authority identify this FileSystem.
      Specified by:
        `getUri` in class `org.apache.hadoop.fs.FileSystem`
      Returns:
        the URI whose scheme and authority identify this FileSystem.

    - #### getDefaultPort

          protected int getDefaultPort()

      Get the default port for this file system.
      Overrides:
        `getDefaultPort` in class `org.apache.hadoop.fs.FileSystem`
      Returns:
        the default port or 0 if there isn't one

    - #### open

          public org.apache.hadoop.fs.FSDataInputStream open(org.apache.hadoop.fs.Path f,
                                                             int bufferSize)
                                                      throws IOException

      Opens an FSDataInputStream at the indicated Path.

      IMPORTANT: the returned `FSDataInputStream` does not support the `PositionReadable` and `Seekable` methods.

      Specified by:
        `open` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `f` - the file name to open
        `bufferSize` - the size of the buffer to be used.
      Throws:
        `IOException`

    - #### permissionToString

          public static String permissionToString(org.apache.hadoop.fs.permission.FsPermission p)

      Converts a `FsPermission` to a Unix octal representation.
      Parameters:
        `p` - the permission.
      Returns:
        the Unix string symbolic reprentation.

    - #### create

          public org.apache.hadoop.fs.FSDataOutputStream create(org.apache.hadoop.fs.Path f,
                                                                org.apache.hadoop.fs.permission.FsPermission permission,
                                                                boolean overwrite,
                                                                int bufferSize,
                                                                short replication,
                                                                long blockSize,
                                                                org.apache.hadoop.util.Progressable progress)
                                                         throws IOException

      Opens an FSDataOutputStream at the indicated Path with write-progress reporting.

      IMPORTANT: The `Progressable` parameter is not used.

      Specified by:
        `create` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `f` - the file name to open.
        `permission` - file permission.
        `overwrite` - if a file with this name already exists, then if true, the file will be overwritten, and if false an error will be thrown.
        `bufferSize` - the size of the buffer to be used.
        `replication` - required block replication for the file.
        `blockSize` - block size.
        `progress` - progressable.
      Throws:
        `IOException`
      See Also:
        `setPermission(Path, FsPermission)`

    - #### append

          public org.apache.hadoop.fs.FSDataOutputStream append(org.apache.hadoop.fs.Path f,
                                                                int bufferSize,
                                                                org.apache.hadoop.util.Progressable progress)
                                                         throws IOException

      Append to an existing file (optional operation).

      IMPORTANT: The `Progressable` parameter is not used.

      Specified by:
        `append` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `f` - the existing file to be appended.
        `bufferSize` - the size of the buffer to be used.
        `progress` - for reporting progress if it is not null.
      Throws:
        `IOException`

    - #### truncate

          public boolean truncate(org.apache.hadoop.fs.Path f,
                                  long newLength)
                           throws IOException

      Truncate a file.
      Overrides:
        `truncate` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `f` - the file to be truncated.
        `newLength` - The size the file is to be truncated to.
      Throws:
        `IOException`

    - #### concat

          public void concat(org.apache.hadoop.fs.Path f,
                             org.apache.hadoop.fs.Path[] psrcs)
                      throws IOException

      Concat existing files together.
      Overrides:
        `concat` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `f` - the path to the target destination.
        `psrcs` - the paths to the sources to use for the concatenation.
      Throws:
        `IOException`

    - #### rename

          public boolean rename(org.apache.hadoop.fs.Path src,
                                org.apache.hadoop.fs.Path dst)
                         throws IOException

      Renames Path src to Path dst. Can take place on local fs or remote DFS.
      Specified by:
        `rename` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### delete

          @Deprecated
          public boolean delete(org.apache.hadoop.fs.Path f)
                                     throws IOException

      Deprecated. Use delete(Path, boolean) instead
      Delete a file.
      Overrides:
        `delete` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### delete

          public boolean delete(org.apache.hadoop.fs.Path f,
                                boolean recursive)
                         throws IOException

      Delete a file.
      Specified by:
        `delete` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `f` - the path to delete.
        `recursive` - if path is a directory and set to true, the directory is deleted else throws an exception. In case of a file the recursive can be set to either true or false.
      Returns:
        true if delete is successful else false.
      Throws:
        `IOException`

    - #### listStatus

          public org.apache.hadoop.fs.FileStatus[] listStatus(org.apache.hadoop.fs.Path f)
                                                       throws IOException

      Get `FileStatus` of files/directories in the given path. If path corresponds to a file then `FileStatus` of that file is returned. Else if path represents a directory then `FileStatus` of all files/directories inside given path is returned.
      Specified by:
        `listStatus` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `f` - given path
      Returns:
        the statuses of the files/directories in the given path
      Throws:
        `IOException`

    - #### listStatusBatch

          public org.apache.hadoop.fs.FileSystem.DirectoryEntries listStatusBatch(org.apache.hadoop.fs.Path f,
                                                                                  byte[] token)
                                                                           throws FileNotFoundException,
                                                                                  IOException

      Get `DirectoryEntries` of the given path. `DirectoryEntries` contains an array of `FileStatus`, as well as iteration information.
      Overrides:
        `listStatusBatch` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `f` - given path
      Returns:
        `DirectoryEntries` for given path
      Throws:
        `FileNotFoundException`
        `IOException`

    - #### setWorkingDirectory

          public void setWorkingDirectory(org.apache.hadoop.fs.Path newDir)

      Set the current working directory for the given file system. All relative paths will be resolved relative to it.
      Specified by:
        `setWorkingDirectory` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `newDir` - new directory.

    - #### getWorkingDirectory

          public org.apache.hadoop.fs.Path getWorkingDirectory()

      Get the current working directory for the given file system
      Specified by:
        `getWorkingDirectory` in class `org.apache.hadoop.fs.FileSystem`
      Returns:
        the directory pathname

    - #### mkdirs

          public boolean mkdirs(org.apache.hadoop.fs.Path f,
                                org.apache.hadoop.fs.permission.FsPermission permission)
                         throws IOException

      Make the given file and all non-existent parents into directories. Has the semantics of Unix 'mkdir -p'. Existence of the directory hierarchy is not an error.
      Specified by:
        `mkdirs` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### getFileStatus

          public org.apache.hadoop.fs.FileStatus getFileStatus(org.apache.hadoop.fs.Path f)
                                                        throws IOException

      Return a file status object that represents the path.
      Specified by:
        `getFileStatus` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `f` - The path we want information from
      Returns:
        a FileStatus object
      Throws:
        `FileNotFoundException` - when the path does not exist; IOException see specific implementation
        `IOException`

    - #### getHomeDirectory

          public org.apache.hadoop.fs.Path getHomeDirectory()

      Return the current user's home directory in this filesystem. The default implementation returns "/user/$USER/".
      Overrides:
        `getHomeDirectory` in class `org.apache.hadoop.fs.FileSystem`

    - #### getTrashRoot

          public org.apache.hadoop.fs.Path getTrashRoot(org.apache.hadoop.fs.Path fullPath)

      Get the root directory of Trash for a path in HDFS. 1. File in encryption zone returns /ez1/.Trash/username. 2. File not in encryption zone, or encountered exception when checking the encryption zone of the path, returns /users/username/.Trash. Caller appends either Current or checkpoint timestamp for trash destination. The default implementation returns "/user/username/.Trash".
      Overrides:
        `getTrashRoot` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `fullPath` - the trash root of the path to be determined.
      Returns:
        trash root

    - #### setOwner

          public void setOwner(org.apache.hadoop.fs.Path p,
                               String username,
                               String groupname)
                        throws IOException

      Set owner of a path (i.e. a file or a directory). The parameters username and groupname cannot both be null.
      Overrides:
        `setOwner` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `p` - The path
        `username` - If it is null, the original username remains unchanged.
        `groupname` - If it is null, the original groupname remains unchanged.
      Throws:
        `IOException`

    - #### setPermission

          public void setPermission(org.apache.hadoop.fs.Path p,
                                    org.apache.hadoop.fs.permission.FsPermission permission)
                             throws IOException

      Set permission of a path.
      Overrides:
        `setPermission` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `p` - path.
        `permission` - permission.
      Throws:
        `IOException`

    - #### setTimes

          public void setTimes(org.apache.hadoop.fs.Path p,
                               long mtime,
                               long atime)
                        throws IOException

      Set access time of a file
      Overrides:
        `setTimes` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `p` - The path
        `mtime` - Set the modification time of this file. The number of milliseconds since Jan 1, 1970. A value of -1 means that this call should not set modification time.
        `atime` - Set the access time of this file. The number of milliseconds since Jan 1, 1970. A value of -1 means that this call should not set access time.
      Throws:
        `IOException`

    - #### setReplication

          public boolean setReplication(org.apache.hadoop.fs.Path src,
                                        short replication)
                                 throws IOException

      Set replication for an existing file.
      Overrides:
        `setReplication` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `src` - file name
        `replication` - new replication
      Returns:
        true if successful; false if file does not exist or is a directory
      Throws:
        `IOException`

    - #### modifyAclEntries

          public void modifyAclEntries(org.apache.hadoop.fs.Path path,
                                       List<org.apache.hadoop.fs.permission.AclEntry> aclSpec)
                                throws IOException

      Modify the ACL entries for a file.
      Overrides:
        `modifyAclEntries` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `path` - Path to modify
        `aclSpec` - describing modifications
      Throws:
        `IOException`

    - #### removeAclEntries

          public void removeAclEntries(org.apache.hadoop.fs.Path path,
                                       List<org.apache.hadoop.fs.permission.AclEntry> aclSpec)
                                throws IOException

      Remove the specified ACL entries from a file
      Overrides:
        `removeAclEntries` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `path` - Path to modify
        `aclSpec` - describing entries to remove
      Throws:
        `IOException`

    - #### removeDefaultAcl

          public void removeDefaultAcl(org.apache.hadoop.fs.Path path)
                                throws IOException

      Removes the default ACL for the given file
      Overrides:
        `removeDefaultAcl` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `path` - Path from which to remove the default ACL.
      Throws:
        `IOException`

    - #### removeAcl

          public void removeAcl(org.apache.hadoop.fs.Path path)
                         throws IOException

      Remove all ACLs from a file
      Overrides:
        `removeAcl` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `path` - Path from which to remove all ACLs
      Throws:
        `IOException`

    - #### setAcl

          public void setAcl(org.apache.hadoop.fs.Path path,
                             List<org.apache.hadoop.fs.permission.AclEntry> aclSpec)
                      throws IOException

      Set the ACLs for the given file
      Overrides:
        `setAcl` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `path` - Path to modify
        `aclSpec` - describing modifications, must include entries for user, group, and others for compatibility with permission bits.
      Throws:
        `IOException`

    - #### getAclStatus

          public org.apache.hadoop.fs.permission.AclStatus getAclStatus(org.apache.hadoop.fs.Path path)
                                                                 throws IOException

      Get the ACL information for a given file
      Overrides:
        `getAclStatus` in class `org.apache.hadoop.fs.FileSystem`
      Parameters:
        `path` - Path to acquire ACL info for
      Returns:
        the ACL information in JSON format
      Throws:
        `IOException`

    - #### getContentSummary

          public org.apache.hadoop.fs.ContentSummary getContentSummary(org.apache.hadoop.fs.Path f)
                                                                throws IOException

      Overrides:
        `getContentSummary` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### getQuotaUsage

          public org.apache.hadoop.fs.QuotaUsage getQuotaUsage(org.apache.hadoop.fs.Path f)
                                                        throws IOException

      Overrides:
        `getQuotaUsage` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### getFileChecksum

          public org.apache.hadoop.fs.FileChecksum getFileChecksum(org.apache.hadoop.fs.Path f)
                                                            throws IOException

      Overrides:
        `getFileChecksum` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### getDelegationToken

          public org.apache.hadoop.security.token.Token<?> getDelegationToken(String renewer)
                                                                       throws IOException

      Specified by:
        `getDelegationToken` in interface `org.apache.hadoop.security.token.DelegationTokenIssuer`
      Overrides:
        `getDelegationToken` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### renewDelegationToken

          public long renewDelegationToken(org.apache.hadoop.security.token.Token<?> token)
                                    throws IOException

      Throws:
        `IOException`

    - #### cancelDelegationToken

          public void cancelDelegationToken(org.apache.hadoop.security.token.Token<?> token)
                                     throws IOException

      Throws:
        `IOException`

    - #### getRenewToken

          public org.apache.hadoop.security.token.Token<?> getRenewToken()

      Specified by:
        `getRenewToken` in interface `org.apache.hadoop.fs.DelegationTokenRenewer.Renewable`

    - #### setDelegationToken

          public <T extends org.apache.hadoop.security.token.TokenIdentifier> void setDelegationToken(org.apache.hadoop.security.token.Token<T> token)

      Specified by:
        `setDelegationToken` in interface `org.apache.hadoop.fs.DelegationTokenRenewer.Renewable`

    - #### setXAttr

          public void setXAttr(org.apache.hadoop.fs.Path f,
                               String name,
                               byte[] value,
                               EnumSet<org.apache.hadoop.fs.XAttrSetFlag> flag)
                        throws IOException

      Overrides:
        `setXAttr` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### getXAttr

          public byte[] getXAttr(org.apache.hadoop.fs.Path f,
                                 String name)
                          throws IOException

      Overrides:
        `getXAttr` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### getXAttrs

          public Map<String,byte[]> getXAttrs(org.apache.hadoop.fs.Path f)
                                       throws IOException

      Overrides:
        `getXAttrs` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### getXAttrs

          public Map<String,byte[]> getXAttrs(org.apache.hadoop.fs.Path f,
                                              List<String> names)
                                       throws IOException

      Overrides:
        `getXAttrs` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### listXAttrs

          public List<String> listXAttrs(org.apache.hadoop.fs.Path f)
                                  throws IOException

      Overrides:
        `listXAttrs` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### removeXAttr

          public void removeXAttr(org.apache.hadoop.fs.Path f,
                                  String name)
                           throws IOException

      Overrides:
        `removeXAttr` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### getAllStoragePolicies

          public Collection<org.apache.hadoop.hdfs.protocol.BlockStoragePolicy> getAllStoragePolicies()
                                                                                               throws IOException

      Overrides:
        `getAllStoragePolicies` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### getStoragePolicy

          public org.apache.hadoop.hdfs.protocol.BlockStoragePolicy getStoragePolicy(org.apache.hadoop.fs.Path src)
                                                                              throws IOException

      Overrides:
        `getStoragePolicy` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### setStoragePolicy

          public void setStoragePolicy(org.apache.hadoop.fs.Path src,
                                       String policyName)
                                throws IOException

      Overrides:
        `setStoragePolicy` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### unsetStoragePolicy

          public void unsetStoragePolicy(org.apache.hadoop.fs.Path src)
                                  throws IOException

      Overrides:
        `unsetStoragePolicy` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### allowSnapshot

          public void allowSnapshot(org.apache.hadoop.fs.Path path)
                             throws IOException

      Throws:
        `IOException`

    - #### disallowSnapshot

          public void disallowSnapshot(org.apache.hadoop.fs.Path path)
                                throws IOException

      Throws:
        `IOException`

    - #### createSnapshot

          public final org.apache.hadoop.fs.Path createSnapshot(org.apache.hadoop.fs.Path path,
                                                                String snapshotName)
                                                         throws IOException

      Overrides:
        `createSnapshot` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### renameSnapshot

          public void renameSnapshot(org.apache.hadoop.fs.Path path,
                                     String snapshotOldName,
                                     String snapshotNewName)
                              throws IOException

      Overrides:
        `renameSnapshot` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### deleteSnapshot

          public void deleteSnapshot(org.apache.hadoop.fs.Path path,
                                     String snapshotName)
                              throws IOException

      Overrides:
        `deleteSnapshot` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

    - #### getSnapshotDiffReport

          public org.apache.hadoop.hdfs.protocol.SnapshotDiffReport getSnapshotDiffReport(org.apache.hadoop.fs.Path path,
                                                                                          String snapshotOldName,
                                                                                          String snapshotNewName)
                                                                                   throws IOException

      Throws:
        `IOException`

    - #### getSnapshottableDirectoryList

          public org.apache.hadoop.hdfs.protocol.SnapshottableDirectoryStatus[] getSnapshottableDirectoryList()
                                                                                                       throws IOException

      Throws:
        `IOException`

    - #### hasPathCapability

          public boolean hasPathCapability(org.apache.hadoop.fs.Path path,
                                           String capability)
                                    throws IOException

      This filesystem's capabilities must be in sync with that of `DistributedFileSystem.hasPathCapability()` except where the feature is not exposed (e.g. symlinks).
      Specified by:
        `hasPathCapability` in interface `org.apache.hadoop.fs.PathCapabilities`
      Overrides:
        `hasPathCapability` in class `org.apache.hadoop.fs.FileSystem`
      Throws:
        `IOException`

Copyright © 2008–2022 Apache Software Foundation. All rights reserved.